// cupwarmer.h

// I/O Defines
#define Cup		0			// ANS0 - Coffee Cup Weight
#define Tcontrol	4			// ANS4 - Temperature Control
#define Theater		5			// ANS5 - Temperature of Heater

#define Heater		RA1			// Output to TRIAC
#define E		RA2			// LCD clock E
#define Button		RA3			// Calibration Button 
#define RS		RA4			// LCD ready to send
#define RW		RA5			// LCD read write


// EEPROM Defines
// Name			Address			Description
#define cupL		0			// Low byte to cup weight
#define cupH		1			// High byte to cup weight
#define iStateL		2			// iState
#define iStateH		3
#define TStateL		4			// Last Temperature state
#define TStateH		5	

// Constants
const pScale =1;				//  PID scalar - not used
const pGain = 10;				//	pGain - Proportional Gain
const iGain = 512;				//	iGain - Integral Gain
const dGain = 2;				//	dGain - Differential Gain
const iMax = 4096;				//	iMax - Integral Max
const iMin = -4096;				//	iMin - Integral Min 


//Subroutines
extern void calibrate_cup(void);
extern void read_cup(void);
extern void sleepnow(void);
extern void control(void);
extern void convert(unsigned int Tin);

// Functions
extern int PID(int error, unsigned int T);
extern unsigned int adc_read(unsigned char channel );
extern void itoa10(unsigned char *buf, int i); 
